#!/usr/bin/env python3
from formulas import p, zero, base, add

def normalize(P):
    i = next(i for i,t in enumerate(P) if t)
    s = pow(P[i], -1, p)
    return tuple(s * c % p for c in P)

def scalarmul(P, n):
    if n < 0:
        raise NotImplementedError('need n ≥ 0')
    assert n >= 0
    R = zero
    while n:
        if n % 2:
            R = add(R, P)
        P = add(P, P)
        n >>= 1
    return normalize(R)

if __name__ == '__main__':

    import signal
    from random import SystemRandom

    signal.alarm(600)

    sec = SystemRandom().randrange(p**2)
    pub = scalarmul(base, sec)
    print(f'{pub = }')

    sol = int(input(), 0)

    if not 0 <= sol < p**2:
        exit(1)

    chk = scalarmul(base, sol)

    if chk != pub:
        exit(1)

    print(open('flag.txt').read().strip())

